# -*- coding: utf-8 -*-
"""Taller de Bases de Datos - Análisis Bibliográfico.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1Lg7yP1mM7fyfqsdcLtvaAIBA-3q_pTA4
"""

import pandas as pd
import nltk
from nltk.tokenize import sent_tokenize, word_tokenize
from nltk.corpus import stopwords
from nltk.probability import FreqDist
import matplotlib.pyplot as plt
from collections import Counter
from wordcloud import WordCloud
import string

# Descargar stopwords
nltk.download('stopwords')

nltk.download('punkt')

stop_words = set(stopwords.words('english'))

df = pd.read_csv('sample_data/scopus.csv')
df.head()

grouped = df.groupby('Source title')['Title'].count()
plt.figure(figsize=(20, 10))
grouped.plot(kind='bar')
plt.show()

grouped = df.groupby('Source title')['Title'].count().sort_values(ascending=False)
top_sources = grouped.head(10)
top_sources.plot(kind='bar', color='skyblue')
plt.title('Fuentes con más artículos publicados')
plt.xlabel('Source title')
plt.ylabel('Número de artículos')
plt.show()

# Función para limpiar y preparar texto
def clean_text(text):
    text = text.lower()
    text = text.translate(str.maketrans('', '', string.punctuation))
    return ' '.join([word for word in text.split() if word not in stop_words])

# Aplicar la limpieza de texto a los títulos
df['clean_title'] = df['Title'].apply(clean_text)

# Contar palabras en todos los títulos
word_counts = Counter()
df['clean_title'].str.split().apply(word_counts.update)

# Crear un DataFrame a partir del contador de palabras
word_df = pd.DataFrame(word_counts.items(), columns=['Word', 'Frequency'])

# Ordenar las palabras por frecuencia de aparición, de mayor a menor
word_df = word_df.sort_values(by='Frequency', ascending=False).reset_index(drop=True)

# Añadir columna de rank
word_df['Rank'] = word_df['Frequency'].rank(method='dense', ascending=False)

# Mostrar el DataFrame de palabras ordenadas por rango
word_df.head(15)

# Aplicar la limpieza de texto a los títulos
df['clean_title'] = df['Title'].apply(clean_text)

# Concatenar todos los títulos limpios en un solo texto
text = ' '.join(df['clean_title'])

wordcloud = WordCloud(width = 950, height = 400, background_color ='white').generate(text)

plt.figure(figsize=(10, 5))
plt.imshow(wordcloud, interpolation='bilinear')
plt.axis('on')
plt.show()

import matplotlib.pyplot as plt
word_df.sort_values(by='Frequency', ascending=False).head(15).plot(x='Word', y='Frequency', kind='bar')
plt.xlabel('Word')
_ = plt.ylabel('Frequency')

# Contar palabras en todos los títulos
word_counts = Counter()
df['Title'].apply(lambda title: word_counts.update(clean_text(title)))

# Determinar un número de palabras clave a considerar (e.g., top 10)
num_keywords = 15
keywords = [word for word, count in word_counts.most_common(num_keywords)]

# Función para contar cuántas palabras clave contiene cada título
def count_keywords(title):
    words = clean_text(title)
    return sum(word in words for word in keywords)

# Contar las palabras clave por título
df['keyword_count'] = df['Title'].apply(count_keywords)

# Ordenar el DataFrame por 'keyword_count' de forma descendente
df_sorted = df.sort_values(by='keyword_count', ascending=False)

# Graficar los top 10 artículos con más palabras clave
plt.figure(figsize=(10, 5))
plt.bar(df_sorted['Title'].head(15), df_sorted['keyword_count'].head(15), color='skyblue')
plt.xticks(rotation=90)
plt.xlabel('Artículos')
plt.ylabel('Cantidad de palabras clave')
plt.title('Top 10 artículos con mayor cantidad de palabras clave')
plt.tight_layout()  # Ajusta automáticamente los parámetros de la subtrama
plt.show()

# Seleccionar los abstracts de los artículos con más palabras clave
top_abstracts = df.sort_values(by='keyword_count', ascending=False).head(5)['Abstract']

# Función para resumir un abstract
def summarize_abstract(abstract):
    sentences = sent_tokenize(abstract)
    word_freq = FreqDist(clean_text(abstract))
    scores = {sentence: sum(word_freq[word] for word in word_tokenize(sentence.lower()) if word in word_freq) for sentence in sentences}
    summary_sentences = sorted(scores, key=scores.get, reverse=True)[:5]  # Tomar las 3 oraciones con mayor puntuación
    return ' '.join(summary_sentences)

# Aplicar la función de resumen a cada abstract seleccionado
top_abstracts_summary = top_abstracts.apply(summarize_abstract)

# Mostrar resúmenes
for i, summary in enumerate(top_abstracts_summary, 1):
    print(f"Resumen {i}:\n{summary}\n")

# Contar la aparición de palabras clave en cada título
df['keyword_count'] = df['Title'].apply(lambda x: sum(word in clean_text(x) for word in word_df))

# Seleccionar los abstracts de los artículos con más palabras clave
top_articles = df.sort_values(by='keyword_count', ascending=False).head(10)

# Función para resumir un abstract
def summarize_abstract(abstract):
    sentences = sent_tokenize(abstract)
    word_freq = FreqDist(clean_text(abstract))
    scores = {sentence: sum(word_freq[word] for word in word_tokenize(sentence.lower()) if word in word_freq) for sentence in sentences}
    summary_sentences = sorted(scores, key=scores.get, reverse=True)[:2]
    return ' '.join(summary_sentences)

# Aplicar la función de resumen a cada abstract seleccionado y almacenar junto con el título
top_articles['Summary'] = top_articles['Abstract'].apply(summarize_abstract)

# Mostrar títulos y resúmenes
for index, row in top_articles.iterrows():
    print(f"Title: {row['Title']}\nSummary: {row['Summary']}\n")

# Aplica la limpieza de texto a los resúmenes
df['clean_abstract'] = df['Abstract'].apply(clean_text)

# Concatenar todos los resúmenes limpios en un solo texto
text = ' '.join(df['clean_abstract'].dropna())  # Asegúrate de excluir valores NaN

# Generar la nube de palabras
wordcloud = WordCloud(width=950, height=400, background_color='white').generate(text)

# Mostrar la nube de palabras
plt.figure(figsize=(10, 5))
plt.imshow(wordcloud, interpolation='bilinear')
plt.axis('off')
plt.show()

# Tokenizar el texto concatenado en palabras
words = text.split()

# Contar la frecuencia de cada palabra
word_counts = Counter(words)

# Convertir el contador a un DataFrame
word_df = pd.DataFrame(word_counts.items(), columns=['keyword', 'Fre'])

# Ordenar el DataFrame por la frecuencia en orden descendente
word_df_sorted = word_df.sort_values(by='Fre', ascending=False)

# Seleccionar las primeras 15 palabras clave
top_15_words = word_df_sorted.head(15)

# Generar el gráfico de barras
plt.figure(figsize=(10, 5))
top_15_words.plot(x='keyword', y='Fre', kind='bar', legend=False)
plt.xlabel('Keyword')
plt.ylabel('Frequency')
plt.title('Top 15 palabras clave ')
plt.xticks(rotation=45)
plt.show()

# Combinar todos los autores en una lista
authors_text = ';'.join(df['Authors'].dropna())

# Contar la frecuencia de cada autor
authors = authors_text.split(';')
author_counts = Counter(authors)

# Convertir el contador a un DataFrame
author_df = pd.DataFrame(author_counts.items(), columns=['author', 'Fre'])

# Ordenar el DataFrame por la frecuencia en orden descendente
author_df_sorted = author_df.sort_values(by='Fre', ascending=False)

# Seleccionar los 10 autores más prolíficos
top_authors = author_df_sorted.head(10)

# Generar el gráfico de barras
plt.figure(figsize=(10, 5))
top_authors.plot(x='author', y='Fre', kind='bar', legend=False)
plt.xlabel('Author')
plt.ylabel('Number of Publications')
plt.title('Top 10 Autores de Numero de Publicaciones')
plt.xticks(rotation=45)
plt.show()

import spacy
from collections import Counter

# Cargar el modelo de spaCy en inglés
nlp = spacy.load('en_core_web_sm')

def get_pos_tags(text):
    doc = nlp(text)
    return [token.pos_ for token in doc]

# Obtener las etiquetas gramaticales de los títulos y resúmenes
df['title_pos'] = df['clean_title'].apply(lambda x: ' '.join(get_pos_tags(x)))
df['abstract_pos'] = df['clean_abstract'].apply(lambda x: ' '.join(get_pos_tags(x)))

# Contar la frecuencia de las categorías gramaticales
title_pos_counts = Counter(' '.join(df['title_pos']).split())
abstract_pos_counts = Counter(' '.join(df['abstract_pos']).split())

# Convertir los contadores a DataFrames
title_pos_df = pd.DataFrame(title_pos_counts.items(), columns=['pos', 'Fre'])
abstract_pos_df = pd.DataFrame(abstract_pos_counts.items(), columns=['pos', 'Fre'])

# Ordenar los DataFrames por frecuencia
title_pos_df_sorted = title_pos_df.sort_values(by='Fre', ascending=False)
abstract_pos_df_sorted = abstract_pos_df.sort_values(by='Fre', ascending=False)

# Visualizar las categorías gramaticales más frecuentes
plt.figure(figsize=(10, 5))
title_pos_df_sorted.head(15).plot(x='pos', y='Fre', kind='bar', legend=False)
plt.xlabel('Part of Speech')
plt.ylabel('Frequency')
plt.title('Top 15 Parts of Speech in Titles')
plt.xticks(rotation=45)
plt.show()

plt.figure(figsize=(10, 5))
abstract_pos_df_sorted.head(15).plot(x='pos', y='Fre', kind='bar', legend=False)
plt.xlabel('Part of Speech')
plt.ylabel('Frequency')
plt.title('Top 15 categorias gramaticales ')
plt.xticks(rotation=45)
plt.show()